package org.synbiowave.restrsites;

import java.util.HashMap;
import java.util.List;
import java.util.Vector;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.jdo.Query;

import org.synbiowave.AbstractSynBioWaveRobot;
import org.synbiowave.database.PMF;
import org.synbiowave.restrsites.db.DBEnzymes;
import org.synbiowave.workspace.Sequence;

import com.google.wave.api.Blip;
import com.google.wave.api.event.Event;
public class RSitesFinder {
	
	public static void init(List<Sequence> sequences, AbstractSynBioWaveRobot servlet,Event event,String eName){
		try{
	  
			String eSeq =	"";
			
			Query q = PMF.get().getPersistenceManager().newQuery(DBEnzymes.class,"name==\""+ eName +"\"");
			List<DBEnzymes> lstEnzyme =  (List<DBEnzymes>) q.execute();
			Vector<Integer> vecStart = new Vector<Integer>();
			Vector<Integer> vecEnd = new Vector<Integer>();
			 if(lstEnzyme!=null){
				 	eSeq = getSequenceRegExp(lstEnzyme.get(0).getEnzymeSequence());
				 	int cut = lstEnzyme.get(0).getCut();
				 	for (Sequence seq : sequences) {
				 		
				 		Pattern p = Pattern.compile(eSeq);
						Matcher m = p.matcher(seq.getSequence());
						while (m.find()) {
							vecStart.add(m.start());
							vecEnd.add(m.end());
						}

				 	Blip blp = event.getWavelet().reply("\n: " + eName + "  Occurances:" + vecStart.size() + "\n");
				 	for(int i=0;i<vecStart.size();i++)
				 	   blp.append("     "+ (i+1) + ") Start:" + (vecStart.get(i)+1) + "   End:" + (vecEnd.get(i)+1)+"   Cut:" + (vecStart.get(i)+1+cut)+"\n");
				 			((RsitesServlet)servlet).showGadgetViewVec(blp, "", seq.getSequence(),vecStart,vecEnd);
				 		//	(servlet).showGadgetView(blp, "", seq.getSequence());
				 	}
			 }
		}
			catch(Exception e){
			event.getWavelet().reply("\n: Error finding restriction sites " + e.getMessage());
			
		}
	}

	public static String getSequenceRegExp(String enzymeSequence) {
		// TODO Auto-generated method stub
		//enzymeSequence = "(N*(" + enzymeSequence + ")N*)";
		HashMap<String,String> hmap = new HashMap<String,String>();
		hmap.put("G",	"G");
		hmap.put("A",	"A");
		hmap.put("T",	"T");
		hmap.put("C",	"C");
		hmap.put("R",	"[GA]");
		hmap.put("Y",	"[TC]");
		hmap.put("M",	"[AC]");
		hmap.put("K",	"[GT]");
		hmap.put("S",	"[GC]");
		hmap.put("W",	"[AT]");
		hmap.put("H",	"[ACT]");
		hmap.put("B",	"[GTC]");	
		hmap.put("V",	"[GCA]");	
		hmap.put("D",	"[GAT]");	
		hmap.put("N",	"[GATC]");
		
		java.util.Iterator<String> it =  hmap.keySet().iterator();
		while(it.hasNext()){
			String strkey = it.next();
			enzymeSequence = enzymeSequence.replaceAll(strkey, hmap.get(strkey));
			enzymeSequence = enzymeSequence.replaceAll(strkey.toLowerCase(), hmap.get(strkey));
		}
		 
		return enzymeSequence;
		
	}
	
	
	
/*	private static void publishSequence(Sequence translation){
		
		translation.setAuthor(translation.getAuthor());
		translation.publish(servlet, event.getWavelet(), true);
	
		servlet.showGadgetView(event.getWavelet().reply("\n"),
				translation.getName(), translation.getSequence());
	}*/
}
