package org.synbiowave.restrsites;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Vector;

import javax.jdo.Query;

import org.synbiowave.AbstractSynBioWaveRobot;
import org.synbiowave.database.DBManager;
import org.synbiowave.database.PMF;
import org.synbiowave.menu.MenuItem;
import org.synbiowave.menu.MenuItemFactory;
import org.synbiowave.menu.items.Formular;
import org.synbiowave.restrsites.db.DBEnzymes;
import org.synbiowave.restrsites.db.DataFetcher;
import org.synbiowave.restrsites.menucallbacks.RsitesCallBack;
import org.synbiowave.utils.SequenceColorUtils;

import com.google.wave.api.Blip;
import com.google.wave.api.Context;
import com.google.wave.api.Gadget;
import com.google.wave.api.event.Event;
import com.google.wave.api.event.GadgetStateChangedEvent;
import com.google.wave.api.event.WaveletSelfAddedEvent;

public class RsitesServlet extends AbstractSynBioWaveRobot {
	
//	private static final long serialVersionUID = -3637163605622939073L;
	
	private HashMap<String,String> enzymes;

	public RsitesServlet() {
		/*	String ver_token = "AOijR2chQUw7I0Y8SJHY6IHBJf49-co5Dtwx8gvUYT1sfAP3pI9_ybJayuDHRoOYqm0SFOhviz-9y8PMOfZ_vzDE_Xt2spCQ_RS1w4NlbT0c0B7liwv4d5vLUTy_nRLMqDeEv-9GdLzSSVb-SR9460UIx-rbsxfjew==";
	String sec_token = "392";
	setupVerificationToken(ver_token, sec_token);
	*/
		super.setupOAuth("454031486467","0a5nz80vquPcvlskUoJL7X6G","http://gmodules.com/api/rpc");
		super.setupOAuth("454031486467","0a5nz80vquPcvlskUoJL7X6G","http://sandbox.gmodules.com/api/rpc");
		super.setAllowUnsignedRequests(true);
		}

  @Override
  protected String getRobotName() {
    return "Restriction Sites Robot";
  }

  @Override
  protected String getRobotAvatarUrl() {
    return "http://2010.igem.org/wiki/images/f/f0/Freiburg_10_software_Icon_R.png";
  }

  @Override
  protected String getRobotProfilePageUrl() {
    return "http://www.SynBioWave.org";
  }

  @Override
  public void onWaveletSelfAdded(WaveletSelfAddedEvent event) {
	super.onSynBioWaveRobotSelfAdded(event);}

  	@Capability(contexts = {Context.ALL})
	@Override
	public void onGadgetStateChanged(GadgetStateChangedEvent event){
		super.onSynBioWaveGadgetChanged(event);}

	@Override
	public void createMenu(MenuItem menu, MenuItemFactory mif, Event event) throws Exception {
		MenuItem sequenceMenu = mif.createMenu("Restriction Sites");
		sequenceMenu.setOption("sort", "10");
		menu.appendSubItem(sequenceMenu);
		
		
		
		
			Formular mainMenu = mif.createForm("Select Enzyme","Select Enzyme:");
		//	mainMenu.addInputfield("Enter Enzyme Name:", "0", "order");
			MenuItem lstEnzyme = mainMenu.addList("Enzyme By Name:", "order");
			lstEnzyme.setOption("key", "lstEnzyme");
			// Actually here should be a loop through all the restriction sites and the sequences.
		
			boolean recordsFound=false;
			Query q = PMF.get().getPersistenceManager().newQuery(DBEnzymes.class);
			if((List<DBEnzymes>) q.execute() != null)
				recordsFound = true;
		//    q.deletePersistentAll();
		    
			Vector<DBEnzymes>VecEnzymes = DataFetcher.process(DataFetcher.fetch());
			

			for(int i=0; i < VecEnzymes.size(); i++){
				mainMenu.addListitemToList(lstEnzyme, VecEnzymes.get(i).getName(), VecEnzymes.get(i).getName());
				if(!recordsFound)
					DBManager.store(VecEnzymes.get(i));
			}
			
//			DBEnzymes db_object = new DBEnzymes("EcoRI","GAATTC",2);
//					DBManager.store(db_object);
//					db_object = new DBEnzymes("AciI","CCGC",2);
//					DBManager.store(db_object);
//					db_object = new DBEnzymes("AatI","AGGCC",3);
//					DBManager.store(db_object); 
//					
//			mainMenu.addListitemToList(lstEnzyme, "AciI", "AciI");
//			mainMenu.addListitemToList(lstEnzyme, "AatI", "AatI");
//			
//			mainMenu.addListitemToList(lstEnzyme, "EcoRI", "EcoRI");
			
		sequenceMenu.appendSubItem(mainMenu);
		super.connectMenuCallBack(mainMenu, new RsitesCallBack());
			}
	

	  public void showGadgetViewVec(Blip blip, String name, String sequence,Vector<Integer> start,Vector<Integer> end)
	  {
		  String htmlViewSequences = SequenceColorUtils.getHTMLView(sequence,start,end);
		    String names = "(br /)(br /)(br /)" + name;
		    Gadget seqView = new Gadget("http://samnode.de/SequenceView.xml");
		    seqView.setProperty("names", names + "(br /)(br /)");
		    seqView.setProperty("sequences", htmlViewSequences);
		    blip.append(seqView);
	  }

	  
/*	  public void showGadgetViewVec(Blip blip, Map<String, String> sequences, Vector<Integer> vecStart,Vector<Integer> vecEnd)
	  {
	    String htmlViewSequences = SequenceColorUtils.getHTMLView(new ArrayList(sequences.values()),vecStart,vecEnd);
	    String names = "(br /)(br /)(br /)";
	    String name;
	    for (Iterator localIterator = sequences.keySet().iterator(); localIterator.hasNext(); names = names + name) name = (String)localIterator.next();
	    Gadget seqView = new Gadget("http://samnode.de/SequenceView.xml");
	    seqView.setProperty("names", names + "(br /)(br /)");
	    seqView.setProperty("sequences", htmlViewSequences);
	    blip.append(seqView);
	  }

	  public void showGadgetViewVec(Blip blip, String name, String sequence,Vector<Integer> start,Vector<Integer> end)
	  {
	    Map sequences = new HashMap();
	    sequences.put(name, sequence);
	    showGadgetViewVec(blip, sequences,start,end);
	  }*/
	  
	  
}