package org.synbiowave.utils;

import java.util.Iterator;
import java.util.List;
import java.util.Vector;

import org.synbiowave.biojava.SequenceUtils;
import org.synbiowave.workspace.Sequence;

public class SequenceColorUtils extends SequenceUtils {
	private static char[][] aColorCode = { { 'Y', 'F', 'A', 'I', 'L', 'M', 'V' }, 
	    { 'W' }, 
	    { 'G' }, 
	    { 'P' }, 
	    { 'S', 'D', 'E', 'T' }, 
	    { 'R', 'N', 'K' }, 
	    { 'H' }, 
	    { 'Q' }, 
	    { 'C' } };

	  private static String[] aColors = { "green", "mediumturquoise", "magenta", "gold", "red", "blue", "cornflowerblue", "gray", "saddlebrown" };

	  private static char[][] nColorCode = { { 'U', 'T' }, 
	    { 'A' }, 
	    { 'G' }, 
	    { 'C' } };

	  private static String[] nColors = { "red", "green", "black", "blue" };

	public static String getHTMLView(String sequence,Vector<Integer> start, Vector<Integer> end)
	  {
	    String type = isSequence(sequence);
	    StringBuffer scale = new StringBuffer();
	    StringBuffer numbers = new StringBuffer();
	    int wait = 0;
	    for (int i = 1; i < sequence.length() + 1; ++i)
	      if (i % 5 == 0) {
	        scale.append('|');
	        numbers.append(i);
	        wait = String.valueOf(i).length() - 1;
	      } else {
	        scale.append('\'');
	        if (wait == 0) numbers.append("&nbsp;"); else
	          --wait; 
	      }
	    String htmlView = "(br /)" + scale + "(br /)" + numbers + "(br /)";
	    char[][] colorCode = nColorCode;
	    String[] colors = nColors;
	    if (type.contains("PROTEIN")) {
	      colorCode = aColorCode;
	      colors = aColors;
	    }char[] sa = sequence.toUpperCase().toCharArray();
	    int k=0;
	    boolean found = false;
	    for (char sc : sa){
	    	
	      for (int r = 0; r < colorCode.length; ++r)
	        for (int c = 0; c < colorCode[r].length; ++c)
	          if (colorCode[r][c] == sc){
	        	  for(int i=0;i<start.size();i++){
	        		  if(k>=start.get(i) && k<end.get(i)) { 
	        			  htmlView = htmlView + "(span style='background-color:#66FF99;color:" + colors[r] + ";')" + sc + "(/span)";
	        			  found=true;
	        			  break;
	        		  }
	        	  }
	        		 if(!found)
	        			  htmlView = htmlView + "(span style='color:" + colors[r] + ";')" + sc + "(/span)";
	        	k++;
	        	found = false;
	          }
	          
	        	  
	    }
	    return htmlView + "(br /)(br /)";
	  }

	  public static String getHTMLView(List<String> sequences, Vector<Integer> start,Vector<Integer> end)
	  {
	    int maxLength = 0;
	    String sequence;
	    for (Iterator localIterator1 = sequences.iterator(); localIterator1.hasNext(); maxLength = sequence.length()) { sequence = (String)localIterator1.next(); label35: if (sequence.length() <= maxLength) break label35; }
	    StringBuffer scale = new StringBuffer();
	    StringBuffer numbers = new StringBuffer();
	    int wait = 0;
	    for (int i = 1; i < maxLength + 1; ++i)
	      if (i % 5 == 0) {
	        scale.append('|');
	        numbers.append(i);
	        wait = String.valueOf(i).length() - 1;
	      } else {
	        scale.append('\'');
	        if (wait == 0) numbers.append("&nbsp;"); else
	          --wait; 
	      }
	    String htmlView = "(br /)" + scale + "(br /)" + numbers + "(br /)";
	    for (String sequence1 : sequences) {
	      String type = isSequence(sequence1);
	      int k=0;
	      boolean found = false;
	      for (char sc : sequence1.toUpperCase().toCharArray()){
	    	  for(int i=0;i < start.size();i++){
	    	  if(k>=start.get(i)&&k<=end.get(i)){
	    		  htmlView = htmlView + "(span style='background-color:#66FF99;color:" + getColor(sc, type) + ";')" + sc + "(/span)";
	    		  found = true;
	    		  break;
	    	  }
	    	  }
	    	  if(!found)
	    		  htmlView = htmlView + "(span style='color:" + getColor(sc, type) + ";')" + sc + "(/span)";
	    	  found = false;
	    	  k++;
	      }
	      htmlView = htmlView + "(br /)";
	    }return htmlView + "(br /)";
	  }
}
